/*****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           control.cpp
** UCEL:             Ridici jednotka aplikace.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
******************************************************************************/
/* POZNAMKY ******************************************************************

******************************************************************************/



/* HLAVICKY ******************************************************************/

#include "control.h"

/* FUNCTIONS *****************************************************************/

Sch_Control::Sch_Control()
/* UCEL:     Konstruktor ridici jednotky.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  States tab[EVENTS][STATES] =
   {{// ICO_SEL
     {ST_SEL, &Sch_Control::nothing},               // ST_SEL
     {ST_SEL, &Sch_Control::desel_nod},             // ST_MOV
     {ST_SEL, &Sch_Control::edg_to_sel},            // ST_EDG
     {ST_SEL, &Sch_Control::nod_to_sel},            // ST_NOD
    },
    {// ICO_EDG
     {ST_EDG, &Sch_Control::sel_to_edg},            // ST_SEL
     {ST_SEL, &Sch_Control::desel_nod},             // ST_MOV
     {ST_EDG, &Sch_Control::nothing},               // ST_EDG
     {ST_EDG, &Sch_Control::nod_to_edg},            // ST_NOD
    },
    {// ICO_NODE
     {ST_NOD, &Sch_Control::sel_to_nod},            // ST_SEL
     {ST_SEL, &Sch_Control::desel_nod},             // ST_MOV
     {ST_NOD, &Sch_Control::edg_to_nod},            // ST_EDG
     {ST_NOD, &Sch_Control::nothing},               // ST_NOD
    },
    {// MU_NODE
     {ST_SEL, &Sch_Control::nothing},               // ST_SEL
     {ST_SEL, &Sch_Control::desel_nod},             // ST_MOV
     {ST_EDG, &Sch_Control::sel_nod_e},             // ST_EDG
     {ST_NOD, &Sch_Control::nothing},               // ST_NOD
    },
    {// MU_EDG
     {ST_SEL, &Sch_Control::sel_edg},               // ST_SEL
     {ST_SEL, &Sch_Control::desel_nod},             // ST_MOV
     {ST_EDG, &Sch_Control::nothing},               // ST_EDG
     {ST_NOD, &Sch_Control::add_nod},               // ST_NOD
    },
    {// MU_XXX
     {ST_SEL, &Sch_Control::nothing},               // ST_SEL
     {ST_SEL, &Sch_Control::desel_nod},             // ST_MOV
     {ST_EDG, &Sch_Control::nothing},               // ST_EDG
     {ST_NOD, &Sch_Control::add_nod},               // ST_NOD
    },
    {// MD_NOD
     {ST_MOV, &Sch_Control::sel_nod_s},             // ST_SEL
     {ST_MOV, &Sch_Control::nothing},               // ST_MOV
     {ST_EDG, &Sch_Control::nothing},               // ST_EDG
     {ST_NOD, &Sch_Control::nothing},               // ST_NOD
    },
    {// MM_DWN
     {ST_SEL, &Sch_Control::nothing},               // ST_SEL
     {ST_MOV, &Sch_Control::mov_nod},               // ST_MOV
     {ST_EDG, &Sch_Control::nothing},               // ST_EDG
     {ST_NOD, &Sch_Control::nothing},               // ST_NOD
    },
    {// KB_DEL
     {ST_SEL, &Sch_Control::del_obj},               // ST_SEL
     {ST_MOV, &Sch_Control::nothing},               // ST_MOV
     {ST_EDG, &Sch_Control::nothing},               // ST_EDG
     {ST_NOD, &Sch_Control::nothing},               // ST_NOD
    },
   };

   for(int x = 0; x < EVENTS; ++x)
      for(int y = 0; y < STATES; ++y)
         _tab[x][y] = tab[x][y];

   _filename[0] = '\0';
   _exit = FALSE;
   _state = ST_NOD;
   _node1 =_node2 = _edge = -1;

}

//............................................................................

int Sch_Control::run()
/* UCEL:     Spusti ridici jednotku a ve smycce cte mys + klavesnici.
   VSTUP:
   VRACI:    navratovy kod - 0 = vse OK.
   POZNAMKY:
*/
{  Event event;

   plot();
   _mouse.show_cursor();
   sel_to_nod();

   while (!_exit)
   {
      _pmevent = _mouse.read(_gc);
      event = NDEF;

      // V kreslici oblasti.
      if (_pmevent.is_in(5, 5, 530, 459))
      {
         switch (_pmevent.type())
         {
            case Sch_MouseEvent::LBUTTONDOWN:
            {
               if( _graf.find_node(_pmevent.x(), _pmevent.y()) != -1 )
                   event = MD_NOD;
               break;
            };

            case Sch_MouseEvent::LBUTTONUP:
            {
               if( _graf.find_node(_pmevent.x(), _pmevent.y()) != -1 )
                   event = MU_NOD;
               else if( _graf.find_edge(_pmevent.x(), _pmevent.y()) != -1 )
                       event = MU_EDG;
               break;
            };

            case Sch_MouseEvent::MOVEDOWN:
            {
               event = MM_DWN;
               break;
            };

         }
      }

      if (_pmevent.type() == Sch_MouseEvent::LBUTTONUP)
      {  // Tlacitko Select
         if (_pmevent.is_in(564, 5, 634, 30))
            event = ICO_SEL;
         // Tlacitko Node
         if (_pmevent.is_in(564, 45, 634, 70))
            event = ICO_NOD;
         // Tlacitko Edge
         if (_pmevent.is_in(564, 85, 634, 110))
            event = ICO_EDG;
         // Tlacitko Exit
         if (_pmevent.is_in(564, 125, 634, 150))
            _exit = TRUE;

         if ( event == NDEF )
            event = MU_XXX;
      }


      if ((_state > -1) && (_state < STATES))
      {  // Zpracujeme event od nysi
         if ((event > -1) && (event < EVENTS))
         {
            (this->*_tab[event][_state].fce)();
            _state = _tab[event][_state].next_state;
         }
         // Zpracujeme event od klavesnice
         if (kbhit())
         {
            if (getch() == 0)
            {  if (getch() == 83)
               {  (this->*_tab[KB_DEL][_state].fce)();
                  _state = _tab[KB_DEL][_state].next_state;
               }
            }
         }

      }

   }
   _gc.close();
   return 0;
}

//............................................................................

Bool Sch_Control::plot()
/* UCEL:     Vykresli desktop.
   VSTUP:
   VRACI:    TRUE = OK.
   POZNAMKY:
*/
{
   _mouse.hide_cursor();

   _gc.rectangle(5, 5, 530, 459);
   _gc.bar(564, 5, 639, 479);

   _gc.rectangle(564, 5, 634, 30);
   _gc.text("Select", 574, 15);

   _gc.rectangle(564, 45, 634, 70);
   _gc.text("Node", 574, 55);

   _gc.rectangle(564, 85, 634, 110);
   _gc.text("Edge", 574, 95);

   _gc.rectangle(564, 125, 634, 150);
   _gc.text("Exit", 574, 135);

   _mouse.show_cursor();

   return(TRUE);
}

//............................................................................

void Sch_Control::ref_graf()
/* UCEL:     Prekresli graf.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   _mouse.hide_cursor();
   _gc.bar(6, 6, 529, 458);
   _graf.plot(_gc);
   _gc.bar(0, 0, 639, 4);
   _gc.bar(0, 0, 4, 479);
   _gc.bar(0, 460, 639, 479);
   _gc.bar(531, 0, 563, 479);
   _mouse.show_cursor();
}

//............................................................................

int Sch_Control::edg_to_sel()
/* UCEL:     Zajistuje prechod programu ze stavu ST_EDG do stavu ST_SEL.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   plot();
   _mouse.hide_cursor();
   _gc.rectangle(564, 5, 636, 32);
   _mouse.show_cursor();
   clear_var();
   return 0;
}

//............................................................................

int Sch_Control::nod_to_sel()
/* UCEL:     Zajistuje prechod programu ze stavu ST_NOD do stavu ST_SEL.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   edg_to_sel();
   return 0;
}

//............................................................................

int Sch_Control::sel_to_edg()
/* UCEL:     Zajistuje prechod programu ze stavu ST_SEL do stavu ST_EDG.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   plot();
   _mouse.hide_cursor();
   _gc.rectangle(564, 85, 636, 112);
   _mouse.show_cursor();
   clear_var();

   return 0;
}

//............................................................................

int Sch_Control::nod_to_edg()
/* UCEL:     Prekresli graf.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   sel_to_edg();

   return 0;
}

//............................................................................

int Sch_Control::sel_to_nod()
/* UCEL:     Prekresli graf.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   plot();
   _mouse.hide_cursor();
   _gc.rectangle(564, 45, 636, 72);
   _mouse.show_cursor();

   clear_var();

   return 0;
}

//............................................................................

int Sch_Control::edg_to_nod()
/* UCEL:     Prekresli graf.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   sel_to_nod();

   return 0;
}

//............................................................................

int Sch_Control::sel_nod_e()
/* UCEL:     Provadi selekci a pridavni hran ve stavu ST_EDG
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  if (_node1 == -1)
   {   _node1 = _graf.find_node(_pmevent.x(), _pmevent.y());
      select_node(_node1);
   }
   else
   {  _node2 = _graf.find_node(_pmevent.x(), _pmevent.y());
      _graf.add_edge(_node1, _node2, "Vrx");
      select_node(_node1);
      _node1 = _node2 = -1;
   }
   ref_graf();
   return 0;
}

//............................................................................

int Sch_Control::sel_nod_s()
/* UCEL:     Provadi selekci vrcholu ve stavu ST_SEL
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  if (_node1 != -1) select_node(_node1);

   _node1 = _graf.find_node(_pmevent.x(), _pmevent.y());
   select_node(_node1);

   if (_edge != -1)
   {  _graf.select_edge(_edge);
      _edge=-1;
   }
   ref_graf();
   return 0;
}

//............................................................................

int Sch_Control::desel_nod()
/* UCEL:     Provadi selekci, deselekci vrcholu.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  return 0;
   select_node(_node1);
   _node1 = -1;
   ref_graf();
   return 0;
}

//............................................................................

int Sch_Control::sel_edg()
/* UCEL:     Provadi selkci hrany ve stavu ST_SEL
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   clear_var();
   _edge = _graf.find_edge(_pmevent.x(), _pmevent.y());
   _graf.select_edge(_edge);
   ref_graf();
   return 0;
}

//............................................................................

int Sch_Control::add_nod()
/* UCEL:     Prida vrchol.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  _graf.add_node(_pmevent.x(), _pmevent.y(), "Vrx");
   ref_graf();
   return 0;
}

//............................................................................

int Sch_Control::mov_nod()
/* UCEL:     Posouva vrchol
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  if (_graf.move_node(_node1, _pmevent.x(), _pmevent.y()))
      ref_graf();

   return 0;
}

//............................................................................

int Sch_Control::del_obj()
/* UCEL:     Maze vyselktovany objekt (vrchol nebo harnu).
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   if (_node1 != -1)
   {  _graf.del_node(_node1);
      _node1 = -1;
   }
   if (_edge != -1)
   {  _graf.del_edge(_edge);
      _edge = -1;
   }
   ref_graf();
   return 0;
}

//............................................................................

void Sch_Control::clear_var(void)
/* UCEL:     Zrusi selekci objektu.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{
   if( _node1 != -1 )
   {
       select_node(_node1);
       _node1 = -1;
   }
   if( _node2 != -1 )
   {
       select_node(_node2);
       _node2 = -1;
   }
   if( _edge != -1 )
   {
       _graf.select_edge(_edge);
       _edge = -1;
   }
   ref_graf();
   return;
}

//............................................................................

void Sch_Control::select_node(int node)
/* UCEL:     Provadi selekci, deselekci vrcholu.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  _graf.select_node(node);
}





