/****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           control.h
** UCEL:             Ridici jednotka aplikace.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
****************************************************************************/
/* POZNAMKY ****************************************************************

****************************************************************************/
#ifndef CONTROL_H
#define CONTROL_H

/* HLAVICKY ****************************************************************/
#include <math.h>
#include <stdlib.h>
#include <assert.h>
#include <iostream.h>
#include <graphics.h>
#include <conio.h>

#include "schsetup.h"
#include "graf.h"
#include "gui_bgi.h"
#include "mouse.h"
#include "mouse_ev.h"

/* TYPY *******************************************************************/
class Sch_Control
/* UCEL: Rid cinnost cele aplikace.
*/
{
public:
   typedef enum { ST_SEL, ST_MOV, ST_EDG, ST_NOD, STATES,
                } State;

   typedef enum { NDEF = -1,
                  ICO_SEL,                      // Mouse Up na ikone Select.
                  ICO_EDG,                      // Mouse Up na ikone Edge.
                  ICO_NOD,                      // Mouse Up na ikone Node.
                  MU_NOD,                       // Mouse Up na vrcholu.
                  MU_EDG,                       // Mouse Up na hrane.
                  MU_XXX,                       // Mouse Up nekde jinde.
                  MD_NOD,                       // Mouse Down na vrcholu
                  MM_DWN,                       // Mouse MoveDown (v grafu).
                  KB_DEL,                       // Stisknuta klavesa Del.
                  EVENTS,                       // Pocet Eventu.
                } Event;

   typedef int (Sch_Control::*Ptr_mf)();

   Sch_Control();
   int run();

private:
   typedef struct
   {  State next_state;
      Ptr_mf fce;
   } States;

   Bool plot();
   void ref_graf();

   inline int nothing() { return 0; }
   int edg_to_sel();
   int nod_to_sel();
   int sel_to_edg();
   int nod_to_edg();
   int sel_to_nod();
   int edg_to_nod();
   int sel_nod_s();
   int sel_nod_e();
   int desel_nod();
   int sel_edg();
   int add_nod();
   int mov_nod();
   int del_obj();
   void clear_var(void);
   void select_node(int node);

   States _tab[EVENTS][STATES];
   Sch_Graf _graf;
   Sch_GuiBgi _gc;
   Sch_Mouse _mouse;
   Sch_MouseEvent _pmevent;
   char _filename[80];
   Bool _exit;
   State _state;
   int _node1, _node2;
   int _edge;

};
#endif