/****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           edge.cpp
** UCEL:             Implementace hrany.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
****************************************************************************/
/* POZNAMKY ****************************************************************

****************************************************************************/

/* HLAVICKY ****************************************************************/
#include "edge.h"

/*-------------------------------------------------------------------------*/

Sch_Edge::Sch_Edge(Sch_Node* start, Sch_Node* final, char* name)
:  _start(start),
   _final(final),
   _select(FALSE)
{  strncpy(_name, name, NAMEL);
}

//...........................................................................

void Sch_Edge::change_name(char* name)
{  strncpy(_name, name, NAMEL);
}

//...........................................................................

void Sch_Edge::plot(Sch_GuiBgi gui) const
{
   double x1, y1;
   double x2, y2;

   x1 = _start->x();
   y1 = _start->y();
   x2 = _final->x();
   y2 = _final->y();

   if (_select)
   {  gui.set_pen_style(Sch_GuiBgi::DOTTED_PEN);
      gui.plot(x1, y1, x2, y2);
      gui.set_pen_style(Sch_GuiBgi::NORMAL_PEN);
   }
   else gui.plot(x1, y1, x2, y2);
}

//...........................................................................

const char* Sch_Edge::name() const {return _name;}

//...........................................................................

const Sch_Node* Sch_Edge::start() const {return _start;}

//...........................................................................

const Sch_Node* Sch_Edge::final(void) const {return _final;}

//...........................................................................

void Sch_Edge::select()
/* UCEL:     Nastavi nebo schodi vlajku _select.
             Tj. jestli je hrana oznacena.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  _select = _select ? FALSE : TRUE;

   return;
}
