/****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           edge.h
** UCEL:             Implementace hrany.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
****************************************************************************/
/* POZNAMKY ****************************************************************

****************************************************************************/
#ifndef EDGE_H
#define EDGE_H


/* HLAVICKY ****************************************************************/
#include <stdlib.h>
#include <iostream.h>
#include <string.h>

#include "schsetup.h"
#include "gui_bgi.h"
#include "node.h"

/* TYPY ********************************************************************/
class Sch_Edge
/* UCEL: Reprezentuje jednotlive hrany a zajistuje jejich zobrazovani.
*/
{
public:

   Sch_Edge(Sch_Node* start, Sch_Node* final, char* name);    /* Konstruktor */

   void change_name(char* name);
   void select(void);

   void plot(Sch_GuiBgi gui) const;
   inline const char* name() const;
   inline const Sch_Node* start() const;
   inline const Sch_Node* final() const;

private:
   Sch_Node* _start;
   Sch_Node* _final;
   enum { NAMEL = 20, };                        /* Max delka jmena */
   char _name[NAMEL+1];
   Bool _select;

};

#endif