/****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           graf.h
** UCEL:             Implementace grafu.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
****************************************************************************/
/* POZNAMKY ****************************************************************

****************************************************************************/
#ifndef GRAF_H
#define GRAF_H


/* HLAVICKY ****************************************************************/
#include <stdlib.h>
#include <iostream.h>
#include <string.h>
#include <math.h>

#include "schsetup.h"
#include "gui_bgi.h"
#include "node.h"
#include "edge.h"

/* TYPY ********************************************************************/
class Sch_Graf
/* UCEL: Reprezentuje Graf a provadi vsechny operace s grafem.
*/
{
public:

   Sch_Graf();                                  /* Konstruktor */
   ~Sch_Graf();                                 /* Destruktor */


   void plot(Sch_GuiBgi& gui) const;
   Bool add_node(double x, double y, char* name);
   Bool add_edge(int start, int final, char* name);
   Bool del_node(int node);
   Bool del_edge(int edge);
   void ch_node_name(int node, char* name);
   void ch_edge_name(int edge, char* name);
   Bool move_node(int node, double x, double y);
   int find_node(double x, double y);
   int find_edge(double x, double y);
   Bool load(char& name);
   Bool save(char& name);
   void select_node(int node);
   void select_edge(int edge);


private:
   void del_graf();

   enum {MAXNODE = 100, MAXEDGE = 200, };
   Sch_Node* _nodes[MAXNODE];
   Sch_Edge* _edges[MAXEDGE];
   int _num_node;
   int _num_edge;
   double _prec;                                 /* Presnost vyhledavani */
};

#endif