/****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           gui_bgi.h
** UCEL:             Graficke rozhrani pro Borland-BGI 
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
****************************************************************************/
/* POZNAMKY ****************************************************************

****************************************************************************/
#ifndef GUI_BGI_H
#define GUI_BGI_H

/* HLAVICKY ****************************************************************/
#include <math.h>
#include <stdlib.h>
#include <assert.h>
#include <iostream.h>
#include <graphics.h>

#include "schsetup.h"
int sch_main(int, char**);

/* TYPY *******************************************************************/
class Sch_GuiBgi
/* UCEL: Zobrazuje graficka primitiva a ridi obrazovku
*/
{
public:
   enum Color                                   /* Seznam barev */
   {  BLACK, BLUE, GREEN, CYAN,
      RED, MAGENTA, BROWN, LIGHTGRAY,
      DARKGRAY, LIGHTBLUE, LIGHTGREEN, LIGHTCYAN,
      LIGHTRED, LIGHTMAGENTA, YELLOW, WHITE,
      DEFAULT_COLOR = WHITE,
      DEFAULT_BACK = BLACK,
   };
   enum PenStyle                                /* Seznam per */
   {  NORMAL_PEN, THICK_PEN, DOTTED_PEN, DASHED_PEN,
      DEFAULT_PEN = NORMAL_PEN
   };
   enum FontStyle                               /* Seznam fontu */
   {  SYS_FONT, SANS_FONT, ROMAN_FONT,
      DEFAULT_FONT = SYS_FONT
   };
   enum RopMode                                 /* Seznam kreslicich modu */
   {  COPY_ROP, XOR_ROP, AND_ROP, NOT_ROP, OR_ROP,
      DEFAULT_ROP = COPY_ROP
   };

   Sch_GuiBgi();                                /* Konstruktor */
   void close();                                /* Ukonci cinnsot GUI */
   void set_window_coord(double xmin, double ymin,
      double xmax, double ymax);                /* Nastavi uziv. souradnice */

   void circ(double x, double y,                /* Vykresli kruznici o zadanem */
      double radius);                           /*  stredu a polomeru. */

   void plot(double x1, double y1,              /* Vykresli usecku. */
      double x2, double y2);

   void rectangle(double xleft, double ytop,
      double xright, double ybot);

   void bar(double xleft, double ytop,
      double xright, double ybot, enum Color color = DEFAULT_BACK);

   void text(char* t, double x, double y);

   void set_pen_style(PenStyle);
   void set_pen_color(Color);
   void set_font_size(double s);
   void set_font_style(FontStyle);
   void set_rop_mode(RopMode);
   void set_clip_on(double x1, double y1,
                    double x2, double y2);
   void set_clip_off();
   int u2d_x(double x) const;                   /* Prepocet uziv. souradnic */
   int u2d_y(double y) const;                   /*  na sourad. obrazovky */

private:

   double d2u_x(int x) const;                   /* Prepocet sourad.obrazovky */
   double d2u_y(int y) const;                   /*  na uziv souradnice  */

   int u2d_dx(double x) const;                  /* Prepocet uziv. difernci */
   int u2d_dy(double y) const;                  /*  na diference obrazovky */

   double _u_xmin;                              /* Uziv souradnice */
   double _u_xmax;
   double _u_ymin;
   double _u_ymax;

   int _d_xmax;                                 /* Souradnice obrazovky */
   int _d_ymax;

   FontStyle _font;
   double _font_size;

};
#endif