/*****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           mouse.cpp
** UCEL:             Implementace mysi.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
******************************************************************************/
/* POZNAMKY ******************************************************************

******************************************************************************/



/* HLAVICKY ******************************************************************/

#include "mouse.h"

/* FUNKCE *****************************************************************/

//............................................................................

Sch_Mouse::Sch_Mouse()
/* UCEL:     Konstruktor - reset mysi .
   VSTUP:
   VRACI:
   POZNAMKY:
*/
:  _old_lbutton(FALSE)

{  union REGS regs;
   regs.x.ax = 0;
   int86(0x33, &regs, &regs);
   if (regs.x.ax) _installed = TRUE;
   else _installed = FALSE;
}

//............................................................................

void Sch_Mouse::show_cursor()
/* UCEL:     Zobrazeni kurzoru mysi .
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  if (!_installed) return;
   union REGS regs;
   regs.x.ax = 1;
   int86(0x33, &regs, &regs);
}

//............................................................................

void Sch_Mouse::hide_cursor()
/* UCEL:     Skryti kurzoru mysi .
   VSTUP:
   VRACI:
   POZNAMKY:
*/
{  if (!_installed) return;
   union REGS regs;
   regs.x.ax = 2;
   int86(0x33, &regs, &regs);
}

//............................................................................

Bool Sch_Mouse::is_installed() const
/* UCEL:     Zjisteni zda je instalovana mys .
   VSTUP:
   VRACI:    TRUE - nainstalovana, jinak FALSE
   POZNAMKY:
*/
{  return _installed;
}

//............................................................................

Sch_MouseEvent Sch_Mouse::read(Sch_GuiBgi& gc)
/* UCEL:     Preda stav mysi .
   VSTUP:    Odkaz na GUI
   VRACI:    Mouse_Event
   POZNAMKY:
*/
{
   if (!_installed) return Sch_MouseEvent(Sch_MouseEvent::NOT_INSTALLED, .0, .0);

   Sch_MouseEvent::Type type;

   union REGS regs;
   regs.x.ax = 3;
   int86(0x33, &regs, &regs);

   if (regs.x.bx & 1)
   {  if (!_old_lbutton) type = Sch_MouseEvent::LBUTTONDOWN;
      else type = Sch_MouseEvent::MOVEDOWN;
   }
   else
   {  if (!_old_lbutton) type = Sch_MouseEvent::MOVEUP;
      else type = Sch_MouseEvent::LBUTTONUP;
   }

   _old_lbutton = (regs.x.bx & 1);
   return(Sch_MouseEvent(type,  gc.u2d_x(regs.x.cx), gc.u2d_y(regs.x.dx)));
}