/****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           node.cpp
** UCEL:             Implementace vrcholu.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
****************************************************************************/
/* POZNAMKY ****************************************************************

****************************************************************************/

/* HLAVICKY ****************************************************************/
#include "node.h"

/*-------------------------------------------------------------------------*/
/* UCEL:     Konstruktor vrcholu.
   VSTUP:    x,y - souradnice vrcholu.

   POZNAMKY:
*/
Sch_Node::Sch_Node(double x, double y, char* name)
:  _x(x),
   _y(y),
   _size(10),
   _select(FALSE)
{  strncpy(_name, name, NAMEL);
}

//...........................................................................

/* UCEL:     Bezparametricky konstruktor vrcholu.
   VSTUP:

   POZNAMKY:
*/
Sch_Node::Sch_Node()
:  _x(.0),
   _y(.0),
   _size(10)
{  _name[NAMEL]='\0';
}

//...........................................................................

/* UCEL:     Posune vrchol na nove souradnice.
   VSTUP:    x,y - nove souradnice
   VRACI:
   POZNAMKY:
*/
void Sch_Node::move(double x, double y)
{  _x = x;
   _y = y;
}

//...........................................................................

/* UCEL:     Posune vrchol o danou vzdalenost.
   VSTUP:    x,y - vzdalenost v ose X a Y
   VRACI:
   POZNAMKY:
*/
void Sch_Node::move_relative(double x, double y)
{  _x += x;
   _y += y;
}

//...........................................................................

/* UCEL:     Zmeni jmeno vrcholu.
   VSTUP:    name - ukazatel na retezec se jmenem
   VRACI:
   POZNAMKY:
*/
void Sch_Node::change_name(char* name)
{  strncpy(_name, name, NAMEL);
}

//...........................................................................

/* UCEL:     Nastavi nebo schodi vlajku _select.
             Tj. jestli je vrchol oznaceny.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
void Sch_Node::select()
{  _select = _select ? FALSE : TRUE;
}

//...........................................................................

/* UCEL:     Vraci stav vlajky _select.
   VSTUP:
   VRACI:
   POZNAMKY:
*/
Bool Sch_Node::is_select()
{  return _select;
}

//...........................................................................

/* UCEL:     Zobrazi vrchol.
   VSTUP:    gui - odkaz na GUI
   VRACI:
   POZNAMKY:
*/
void Sch_Node::plot(Sch_GuiBgi &gui) const
{  if (_select) gui.circ(_x, _y, _size+2);
   gui.circ(_x, _y, _size);
}

//...........................................................................

/* UCEL:     Vraci jmeno vrcholu.
   VSTUP:
   VRACI:    Ukazatel na jmeno.
   POZNAMKY:
*/
const char* Sch_Node::name() const {return _name;}

//...........................................................................

/* UCEL:     Vraci X souradnic vrcholu.
   VSTUP:
   VRACI:    Souradnici X.
   POZNAMKY:
*/
double Sch_Node::x() const {return _x;}

//...........................................................................

/* UCEL:     Vraci Y souradnic vrcholu.
   VSTUP:
   VRACI:    Souradnici Y.
   POZNAMKY:
*/
double Sch_Node::y() const {return _y;}

//...........................................................................
