/****************************************************************************
** COPYRIGHT (C):    1998 M. Schovanek, M. Kosturik
** PROJEKT:          OOP
** SOUBOR:           node.h
** UCEL:             Implementace vrcholu.
** VERZE             1.0
** JAZYK:            bcc
** CILOVY POCITAC:   IBM PC
** PROGRAMATOR:      Martin Schovanek (SCH)
** HISTORIE UPRAV:
**
****************************************************************************/
/* POZNAMKY ****************************************************************

****************************************************************************/
#ifndef NODE_H
#define NODE_H


/* HLAVICKY ****************************************************************/
#include <stdlib.h>
#include <iostream.h>
#include <string.h>

#include "schsetup.h"
#include "gui_bgi.h"
/* TYPY ********************************************************************/
class Sch_Node
/* UCEL: Reprezentuje jednotlive vrcholy a zajistuje jejich zobrazovani.
*/
{
public:

   Sch_Node(double x, double y, char* name);    /* Konstruktor */
   Sch_Node();

   void move(double x, double y);
   void move_relative(double x, double y);
   void change_name(char* name);
   void select();
   Bool is_select();

   void plot(Sch_GuiBgi &gui) const;
   inline const char* name() const;
   inline double x() const;
   inline double y() const;

private:
   double _x;
   double _y;
   enum { NAMEL = 20, };                        /* Max delka jmena */
   char _name[NAMEL+1];
   double _size;                                /* Polomer vrcholu */
   Bool _select;
};

#endif